;;; kcr-mode.el --- sample major mode for editing LSL.

;; Copyright © 2015, by Kevin Delmas

;; Author: Kevin Delmas (kevin.delmas@onera.fr )
;; Version: 2.0.13
;; Created: 15 Sep 2016
;; Keywords: languages

;; This file is not part of GNU Emacs.

;;; License:

;; You can redistribute this program and/or modify it under the terms of the GNU General Public License version 2.

;;; Code:

;; define several category of keywords
(setq kcr-keywords '( "failure" "condition" "reliability" "design" "space" "then" "default" "root" "else" "comp" "if" "returns" "defs" "evts" "locs" "type" "config" "duration" "mincard" "primary") )
(setq kcr-annot '("@"))
(setq kcr-constants '("empty"))
(setq kcr-functions '("atLeast" "atMost" ":=" "=" "&" "#" "!" "!=" "union" "inter" "->"))

;; generate regex string for each category of keywords
(setq kcr-keywords-regexp (regexp-opt kcr-keywords 'words))
(setq kcr-annot-regexp "@[^\(]+")
(setq kcr-constant-regexp (regexp-opt kcr-constants 'words))
(setq kcr-functions-regexp (regexp-opt kcr-functions ))
(setq kcr-comment-regexp "//.*" )

;; create the list for font-lock.
;; each category of keyword is given a particular face
(setq kcr-font-lock-keywords
      `(
	(,kcr-comment-regexp . font-lock-comment-face) 
        (,kcr-constant-regexp . font-lock-constant-face)
        (,kcr-functions-regexp . font-lock-function-name-face)
        (,kcr-keywords-regexp . font-lock-keyword-face)
	(,kcr-annot-regexp . font-lock-type-face)
        ))

;;;###autoload
(define-derived-mode kcr-mode fundamental-mode
  "kcr mode"
  "Major mode for editing KCR…"

  ;; code for syntax highlighting
  (setq font-lock-defaults '((kcr-font-lock-keywords))))

;; clear memory. no longer needed
(setq kcr-keywords nil)
(setq kcr-annot nil)
(setq kcr-constants nil)
(setq kcr-functions nil)

;; clear memory. no longer needed
(setq kcr-keywords-regexp nil)
(setq kcr-annot-regexp nil)
(setq kcr-constants-regexp nil)
(setq kcr-comment-regexp nil)
(setq kcr-functions-regexp nil)

;; add the mode to the `features' list
(provide 'kcr-mode)

;; Local Variables:
;; coding: utf-8
;; End:

;;; kcr-mode.el ends here
