package analyzers

import java.io.{File, FileWriter}

import translators.DSLCircuitGraphTranslator
import util.analyzers.Z3ExprTranslators

/**
  * Trait for Circuit Graph exportation
  */
trait CircuitGraphExporter extends Exporter with Z3ExprTranslators {
  self: Parsing with SMTTranslation =>

  /**
    * Translate structure function to circuit graph
    *
    * @param file destination file
    */
  def exportToCG(file: File): Unit = {
    val varMap = phi.events.map(p => {
      p._2 -> p._1.toString
    })
    val writer = new FileWriter(file)
    DSLCircuitGraphTranslator.boolExprToCG(toNNF(phi.expr, phi.events.values.toList, _SMTContext), varMap, writer)
    writer.close()
  }
}

