package analyzers

import java.io.File

import util.analyzers.analyzerTypes._
import ast.dsl.{CompAlternative, CompInstanceIdent}
import com.microsoft.z3.Status._
import com.microsoft.z3.{BoolExpr, EnumSort, Expr}
import interpreter.TraceInterpreter
import translators.DSLToHipHOPSTranslator
import util.analyzers._
import util.io.{FileManager,SystemInfo}

import scala.collection.mutable.ListBuffer
import scala.language.postfixOps
import scala.sys.process.Process
import scala.xml.XML

/**
  * Created by kdelmas on 25/09/17.
  */

/**
  * Base trait for solving Design Space Problem (DSE)
  */
trait DSEProblemSolver extends ConfigurationAnalyzer {
  self: Parsing =>

  type Solution = Map[CompInstanceIdent, CompAlternative]

  /**
    * Solution of the DSE problem
    */
  val solution: Option[Solution]

  /**
    * Generation of the substitution var for the given DSE problem
    *
    * @return list of substitution var
    */
  protected def generateDecisionVars(): List[SubstitutionVar]
}



