package analyzers

import java.io.{File, FileWriter}

import translators.DSLToSMVTranslator

/**
  * Trait for SMV exportation
  */
trait SMVExporter extends Exporter {
  self: Parsing =>

  /**
    * Translate structure function to SMV and fault injection models
    *
    * @param directory destination directory
    */
  def exportToSMV(directory: File): Unit = {
    val systemWriter = new FileWriter(directory)
    DSLToSMVTranslator.translateConfiguration(conf, systemWriter)
    systemWriter.close()
    val feiWriter = new FileWriter(new File(directory.getParent, directory.getName.split('.').head + ".fei"))
    DSLToSMVTranslator.makeFEI(conf, feiWriter)
    feiWriter.close()
  }
}
