package analyzers

import ast.dsl.DSLSymbol
import util.analyzers._

import scala.collection.mutable

/**
  * Analysis of the substitutions given in the design space of a DSE problem using SMT problem solving
  */
trait SubstitutionAnalyzerSMT extends SubstitutionAnalyzer with BDDFactoryField {
  self: Parsing with SMTTranslation =>

  lazy val _componentCache: mutable.HashMap[DSLSymbol, Component with RelationBuild with FBDDBuildSMT with FCardinalityBuild] =
    mutable.HashMap.empty

  lazy val substitutions: List[Substitution with LegalAnalyser with AlternativesAnalyser] =
    conf.designSpace.map(sub => {
      new Substitution(sub, this, _componentCache) with LegalAnalyser with AlternativesAnalyser {
        val BDDFactory: BDDFactory with Z3BoolExprToBDDTranslator = self.BDDFactory
      }
    })
}
