/** $Id: dsl.scala 1430 2017-10-17 09:16:44Z kdelmas $
  *
  * @author $Author: kdelmas $
  * @date $Date: 2017-10-17 11:16:44 +0200 (mar. 17 oct. 2017) $ 
  **/
package namespace

import ast.dsl._

package object dsl {
  type PackageMapType = Map[DSLSymbol, PackageDeclaration]
  type IncludeSetType = Set[IncludeDeclaration]
  type OpenSetType = Set[OpenDeclaration]
  type TypeMapType = Map[DSLSymbol, TypeDeclaration]
  type TypeSetType = Set[TypeDeclaration]
  type ComponentMapType = Map[DSLSymbol, ComponentDeclaration]
  type ConfigurationMapType = Map[DSLSymbol, ConfigurationDeclaration]

  type PkgContentsType = (
    PackageMapType,
      IncludeSetType,
      OpenSetType,
      TypeMapType,
      ComponentMapType,
      ConfigurationMapType
    )

  type FlowDeclMapType = Map[DSLSymbol, FlowDeclaration]
  type FlowDefMapType = Map[DSLSymbol, FlowDefinition]
  type CallDefMapType = Map[DSLSymbol, CompCallFlowDefinition]
  type TypeValueSetType = Set[DSLSymbol]
  type EventSetType = Set[DSLSymbol]
  type DesignSpaceMapType = Map[CompInstanceIdent, CompSubstitution]
}
