package old

import analyzers._
import util.analyzers.analyzerTypes._
import ast.dsl.{CompAlternative, CompInstanceIdent}
import com.microsoft.z3.Status._
import com.microsoft.z3._
import translators.translatorsTypes.PathIdentType
import util.analyzers.MeasureTypes.ProbMeasure
import util.analyzers.{ProbaMeasure, SubstitutionVar}
import util.stack.immutable.{AssertionStack => KeepStack}

import scala.collection.immutable.{BitSet, HashMap}
import scala.collection.mutable
import scalaz.Memo

/**
  * Created by kdelmas on 14/04/16.
  */

@deprecated("old version of safety theory","KCR analyser 1.0")
trait UnreliabilityTheory {
  self: Parsing with SMTTranslation with STMDDBuilder =>

  private val concatMerger = (kv1: (PathIdentType, BitSet), kv2: (PathIdentType, BitSet)) => (kv1._1, kv1._2 ++ kv2._2)
  private val keepMerger = (kv1: (PathIdentType, BitSet), kv2: (PathIdentType, BitSet)) => kv1
  private val replaceMerger = (kv1: (PathIdentType, BitSet), kv2: (PathIdentType, BitSet)) => kv2

  private def getChoiceIndex(choice: Seq[(PathIdentType, Option[Int])], of: mddFactory.MDDNode): Int = {
    choice.indexWhere(p => p._1 == of.param.value.path)
  }

  def quickExplain(model: Traversable[(SubstitutionVar, Expr)], solver: (Seq[(PathIdentType, Option[Int])]) => Status): (Status, Traversable[(SubstitutionVar, Expr)]) = {
    val result = mutable.ListBuffer(model.toSeq: _*)
    val choice = model.map(p => p._1.inst.path -> _SMTContext.getValuePos(p._1, p._2)).toSeq
    val toChoice = (c: Seq[(SubstitutionVar, Expr)]) => {
      model.map(p =>
        if (c.contains(p))
          p._1.inst.path -> _SMTContext.getValuePos(p._1, p._2)
        else
          p._1.inst.path -> None
      ).toSeq
    }
    val zero: Traversable[(SubstitutionVar, Expr)] = Nil
    solver(choice) match {
      case SATISFIABLE => (SATISFIABLE, zero)
      case UNKNOWN => (UNKNOWN, zero)
      case UNSATISFIABLE =>
        for (e <- result) {
          _SMTContext.getValuePos(e._1, e._2) match {
            case Some(_) =>
              if (solver(toChoice(result - e)) == Status.UNSATISFIABLE) {
                result -= e
              }
            case None => result -= e
          }
        }
        (UNSATISFIABLE, result)
    }
  }

  def isSafeUnrQuickXplain(objective: Real, model: Traversable[(SubstitutionVar, Expr)]): (Status, Seq[Seq[BoolExpr]]) = {
    val solveur = (m: Seq[(PathIdentType, Option[Int])]) => {
      val unr = computeUnrSimple((STMDDD, m))
      if (unr > objective) {
        UNSATISFIABLE
      } else if (unr <= objective) {
        SATISFIABLE
      } else {
        UNKNOWN
      }
    }
    val (status, conflict) = quickExplain(model, solveur)
    val CNF = conflict.map(e => Seq(_SMTContext.mkEq(e._1.z3Var, e._2))).toSeq
    (status, CNF)
  }

  def isSafeUnrSimple(objective: Real, model: Traversable[(SubstitutionVar, Expr)]): (Status, Seq[Seq[BoolExpr]]) = {
    val unr = computeUnrSimple((STMDDD, model.map(p => p._1.inst.path -> _SMTContext.getValuePos(p._1, p._2)).toSeq))
    if (unr > objective) {
      val conflict = model.filter(e => _SMTContext.getValuePos(e._1, e._2).isDefined)
      val CNF = conflict.map(e => Seq(_SMTContext.mkEq(e._1.z3Var, e._2))).toSeq
      (UNSATISFIABLE, CNF)
    } else if (unr <= objective) {
      (SATISFIABLE, Nil)
    } else {
      (UNKNOWN, Nil)
    }
  }


  private val computeUnrSimple: ((mddFactory.MDD, Seq[(PathIdentType, Option[Int])])) => ProbMeasure = Memo.mutableHashMapMemo {
    (pair: (mddFactory.MDD, Seq[(PathIdentType, Option[Int])])) => {
      val (node, choice) = pair
      node match {
        case n: mddFactory.MDDNode =>
          //choice for the node
          val nodeChoiceIndex = getChoiceIndex(choice, n)
          //choice for sons
          val choiceTail = choice.drop(nodeChoiceIndex + 1)
          choice(nodeChoiceIndex)._2 match {
            case Some(bit) =>
              //si un choix est fait et que la unr du choix est 0, retourne 0 et ajoute le noeud a la clause
              if (n.forall(pair => pair._1.unr(bit) == 0)) {
                ProbaMeasure(0.0)
              } else {
                //calcul de la proba de mes fils
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrSons((pair._2, choiceTail))).toSeq: _*)
                //agregation des clauses renvoyees par les fils
                val over = sonUnr.map(kv => kv._2._1.up * kv._1.unr(bit)).sum
                val under = sonUnr.map(kv => kv._2._1.low * kv._1.unr(bit)).sum
                //calcul la valeur reelle de la defiabilite si tout les fils renvoi une valeur exacte
                // qui est unr(N)= pr(N)*sum(pr(N.sons))
                val real = sonUnr.foldLeft[Option[Real]](Some(0))((acc, pair) => {
                  for (prev <- acc; newPr <- pair._2._1.exact) yield prev + newPr * pair._1.unr(bit)
                })
                ProbaMeasure(over, under, real)
              }
            case None =>
              //si ma defiabilite est nulle alors rien ne sert de calculer celle de mes fils, retourne 0
              //sinon la sur et sous approx sont les sommes des sur sous approx de ses fils
              if (n.forall(pair => pair._1.maxUnr == 0)) {
                ProbaMeasure(0.0)
              } else {
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrSons((pair._2, choiceTail))).toSeq: _*)
                val over = sonUnr.map(pair => pair._2._1.up * pair._1.maxUnr).sum
                val under = sonUnr.map(pair => pair._2._1.low * pair._1.minUnr).sum
                ProbaMeasure(over, under, None)
              }
          }
        case t: mddFactory.Terminal => ProbaMeasure(1)
      }
    }
  }

  /**
    * Theorie de la defiabilite qui renvoi pour un choix donnee le status et la clause de conflit si status est UNSAT
    * sinon le choix initial. On parcours l'arbre des traces avec un budget de defiabilite a depenser, on calcul
    * donc les long des chemins une borne min, max et si possible reel de la defiabilite. Si au bout
    * de l'evaluation d'un groupe de chemins la reponse est UNSAT alors on sait que le modele n'est pas satisfaisant. Dans le cas d'une valuation incomplete
    * Si la surapprox est correcte le modele est correct, la sous approx est incorrect le modele est incorrect, sinon on
    * ne sait pas.
    *
    * @param objective objectif de defiabilite
    * @param choice    choix des substitution
    * @return si le modele satisfait ou non les contrainte et une clause de conflit (CNF)
    */
  val enumVarSafeUnrCache = mutable.HashMap[PathIdentType, SubstitutionVar]()

  def isSafeUnr(objective: Real, model: Traversable[(SubstitutionVar, Expr)]): (Status, Seq[Seq[BoolExpr]]) = {
    def asCube(cube: HashMap[PathIdentType, BitSet]): Seq[Seq[BoolExpr]] = {
      cube.collect({ case (enumVar, set) if set.nonEmpty =>
        val assign = enumVarSafeUnrCache.getOrElseUpdate(enumVar, model.find(p => p._1.inst.path == enumVar).get._1)
        set.map(bit => _SMTContext.mkEq(assign.z3Var, _SMTContext.getValueAtPos(assign, bit).get)).toSeq
      }).toSeq
    }

    def asCNF(cube: HashMap[PathIdentType, BitSet]): Seq[Seq[BoolExpr]] = {
      cube.collect({ case (enumVar, set) if set.nonEmpty =>
        val assign = enumVarSafeUnrCache.getOrElseUpdate(enumVar, model.find(p => p._1.inst.path == enumVar).get._1)
        set.map(bit => _SMTContext.mkEq(assign.z3Var, _SMTContext.getValueAtPos(assign, bit).get)).toSeq
      }).toSeq
    }

    val choice = model.map(p => p._1.inst.path -> _SMTContext.getValuePos(p._1, p._2)).toSeq
    STMDDD match {
      case n: mddFactory.MDDNode =>
        //choice for the node
        val nodeChoiceIndex = getChoiceIndex(choice, n)
        //choice for sons
        val
        choiceTail = choice.drop(nodeChoiceIndex + 1)
        //ce que devrait renvoyer la propagation
        var propagation = BitSet.empty
        //tant que la somme des proba des fils est inferieur à l'objectif, ajout de la nouvelle proba
        val (incompPr, conflitClause) = n.foldLeft((ProbaMeasure(0), HashMap[PathIdentType, BitSet]()))((acc, pair) => {
          val sonAna = computeUnrSons((pair._2, choiceTail))
          //calcul de la proba de l'arc de la racine
          val rootUnr: ProbMeasure = choice(nodeChoiceIndex)._2 match {
            case Some(bit) => ProbaMeasure(pair._1.unr(bit))
            case None => ProbaMeasure(pair._1.maxUnr, pair._1.minUnr, None)
          }
          //calcul de la proba du fils
          val sonPr = sonAna._1 * rootUnr
          val updatedVisited = {
            for (bit <- choice(nodeChoiceIndex)._2) yield acc._2 + (n.param.value.path -> BitSet(bit))
          }.getOrElse(acc._2).merged(sonAna._2)(keepMerger)
          val updateAcc = (acc._1 + sonPr, updatedVisited)
          //si la somme partielle est trop élévée alors on est UNSAT
          if (updateAcc._1 >= objective) {
            choice(nodeChoiceIndex)._2 match {
              case Some(bit) =>
                return (UNSATISFIABLE, asCube(updateAcc._2))
              case None =>
                return (UNSATISFIABLE, asCube(updateAcc._2))
            }
          } else {
            // test propagation
            if (choice(nodeChoiceIndex)._2.isEmpty) {
              propagation ++= pair._1.unr.indices.filter(i => {
                val sonPr = sonAna._1 * ProbaMeasure(pair._1.unr(i))
                acc._1 + sonPr >= objective
              }).toList
            }
            updateAcc
          }
        })

        if (incompPr <= objective)
          (SATISFIABLE, asCube(conflitClause))
        else
          (UNKNOWN, asCNF(HashMap(n.param.value.path -> propagation)))

      case t: mddFactory.Terminal => (UNSATISFIABLE, Seq.empty)
    }

  }

  private val computeUnrSons: ((mddFactory.MDD, Seq[(PathIdentType, Option[Int])])) => (ProbMeasure, HashMap[PathIdentType, BitSet]) = Memo.mutableHashMapMemo {
    (pair: (mddFactory.MDD, Seq[(PathIdentType, Option[Int])])) => {
      val (node, choice) = pair
      node match {
        case n: mddFactory.MDDNode =>
          //choice for the node
          val nodeChoiceIndex = getChoiceIndex(choice, n)
          //choice for sons
          val choiceTail = choice.drop(nodeChoiceIndex + 1)
          choice(nodeChoiceIndex)._2 match {
            case Some(bit) =>
              //si un choix est fait et que la unr du choix est 0, retourne 0 et ajoute le noeud a la clause
              if (n.forall(pair => pair._1.unr(bit) == 0)) {
                (ProbaMeasure(0.0), HashMap(n.param.value.path -> BitSet(bit)))
              } else {
                //calcul de la proba de mes fils
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrSons((pair._2, choiceTail))).toSeq: _*)
                //agregation des clauses renvoyees par les fils
                val visited = HashMap(sonUnr.values.flatMap(_._2).toSeq: _*)
                val over = sonUnr.map(kv => kv._2._1.up * kv._1.unr(bit)).sum
                val under = sonUnr.map(kv => kv._2._1.low * kv._1.unr(bit)).sum
                //calcul la valeur reelle de la defiabilite si tout les fils renvoi une valeur exacte
                // qui est unr(N)= pr(N)*sum(pr(N.sons))
                val real = sonUnr.foldLeft[Option[Real]](Some(0))((acc, pair) => {
                  for (prev <- acc; newPr <- pair._2._1.exact) yield prev + newPr * pair._1.unr(bit)
                })
                (ProbaMeasure(over, under, real), visited + (n.param.value.path -> BitSet(bit)))
              }
            case None =>
              //si ma defiabilite est nulle alors rien ne sert de calculer celle de mes fils, retourne 0
              //sinon la sur et sous approx sont les sommes des sur sous approx de ses fils
              if (n.forall(pair => pair._1.maxUnr == 0)) {
                (ProbaMeasure(0.0), HashMap[PathIdentType, BitSet]())
              } else {
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrSons((pair._2, choiceTail))).toSeq: _*)
                val visited = HashMap(sonUnr.values.flatMap(_._2).toSeq: _*)
                val over = sonUnr.map(pair => pair._2._1.up * pair._1.maxUnr).sum
                val under = sonUnr.map(pair => pair._2._1.low * pair._1.minUnr).sum
                (ProbaMeasure(over, under, None), visited)
              }
          }
        case t: mddFactory.Terminal => (ProbaMeasure(1), HashMap[PathIdentType, BitSet]())
      }
    }
  }

  //TODO very fragile, change it !
  private def getAlternativeIndex(inst: CompInstanceIdent, alt: CompAlternative): Int = {
    val sub = conf.designSpace.find(s => s.instance.path == inst.path).get
    (sub.init +: sub.alternatives).indexOf(alt)
  }

  /**
    * Calcul une surapprox, sous approx et valeur reel (si le choix est complet) de
    * la defiabilite
    *
    * @param choice choix de selection de substiution
    * @return une mesure de la defibailite
    */
  def computeUnrWithMemo(choice: Map[CompInstanceIdent, CompAlternative]): ProbMeasure = {
    Memo.mutableHashMapMemo {
      computeUnrRec
    }((STMDDD, HashMap(choice.toSeq: _*)))
  }

  def computeUnrWithoutMemo(choice: Map[CompInstanceIdent, CompAlternative]): ProbMeasure = {
    computeUnrRec((STMDDD, HashMap(choice.toSeq: _*)))
  }

  private val computeUnrRec: ((mddFactory.MDD, HashMap[CompInstanceIdent, CompAlternative])) => ProbMeasure =
    (pair: (mddFactory.MDD, HashMap[CompInstanceIdent, CompAlternative])) => {
      val (node, choice) = pair
      node match {
        case n: mddFactory.MDDNode =>
          val nodeChoice = for (compAlt <- choice.find(p => n.param.value.path == p._1.path)) yield {
            getAlternativeIndex(n.param.value, compAlt._2)
          }
          nodeChoice match {
            case Some(bit) =>
              //si un choix est fait et que la unr du choix est 0, retourne 0 et ajoute le noeud a la clause
              if (n.forall(pair => pair._1.unr(bit) == 0)) {
                ProbaMeasure(0.0)
              } else {
                //calcul de la proba de mes fils
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrRec((pair._2, choice))).toSeq: _*)
                val over = sonUnr.map(kv => kv._2.up * kv._1.unr(bit)).sum
                val under = sonUnr.map(kv => kv._2.low * kv._1.unr(bit)).sum
                //calcul la valeur reelle de la defiabilite si tout les fils renvoi une valeur exacte
                // qui est unr(N)= pr(N)*sum(pr(N.sons))
                val real = sonUnr.foldLeft[Option[Real]](Some(0))((acc, pair) => {
                  for (prev <- acc; newPr <- pair._2.exact) yield prev + newPr * pair._1.unr(bit)
                })
                ProbaMeasure(over, under, real)
              }
            case None =>
              //si ma defiabilite est nulle alors rien ne sert de calculer celle de mes fils, retourne 0
              //sinon la sur et sous approx sont les sommes des sur sous approx de ses fils
              if (n.forall(pair => pair._1.maxUnr == 0)) {
                ProbaMeasure(0.0)
              } else {
                val sonUnr = HashMap(n.map(pair => pair._1 -> computeUnrRec((pair._2, choice))).toSeq: _*)
                val over = sonUnr.map(pair => pair._2.up * pair._1.maxUnr).sum
                val under = sonUnr.map(pair => pair._2.low * pair._1.minUnr).sum
                ProbaMeasure(over, under, None)
              }
          }
        case t: mddFactory.Terminal => ProbaMeasure(1)
      }
    }
}

trait UnreliabilityTheorySim extends UnreliabilityTheory {
  self: Parsing with SMTTranslation with SubstitutionAnalyzerSim with STMDDBuilderSim =>
}

trait UnreliabilityTheorySMT extends UnreliabilityTheory {
  self: Parsing with SMTTranslation with SubstitutionAnalyzerSMT with STMDDBuilderSMT =>
}