/** $Id: ParsingException.scala 1433 2017-10-19 14:06:15Z kdelmas $
  *
  * @author $Author: kdelmas $
  **/

package parsers.dsl

sealed trait ParsingException extends Exception

case class FileNotFound(path: String) extends ParsingException {
  override def toString = s"parsing error: file '$path' does not exist."
}

case class ParserError(e: Throwable) extends ParsingException {
  override def toString = s"parsing error: '${e.toString}'"
}
