/** $Id: ThrowingErrorListener.scala 1433 2017-10-19 14:06:15Z kdelmas $
  *
  * @author $Author: kdelmas $
  * @date $Date: 2017-10-19 16:06:15 +0200 (jeu. 19 oct. 2017) $ 
  **/

package parsers.dsl

import org.antlr.v4.runtime.{BaseErrorListener, RecognitionException, Recognizer}
import org.antlr.v4.runtime.misc.ParseCancellationException

object ThrowingErrorListener extends BaseErrorListener {
  var error: Option[ParseCancellationException] = None

  override def syntaxError(
                            recognizer: Recognizer[_, _],
                            offendingSymbol: Object,
                            line: Int,
                            charPositionInLine: Int,
                            msg: String,
                            e: RecognitionException): Unit = {
    error = Some(new ParseCancellationException("line " + line + ":" + charPositionInLine + " " + msg))
    throw new ParseCancellationException("line " + line + ":" + charPositionInLine + " " + msg)
  }

}
