package translators

import ast.dsl.Expr
import translators.translatorsTypes.PathIdentType

/**
  * Created by kdelmas on 19/04/16.
  */
trait TranslatorExceptions extends Exception

case class IdentNotInCache(ident: PathIdentType) extends TranslatorExceptions {
  override def toString = s"the ident ${ident.mkString(".")} is not in cache and should be"
}

case class ExprNotHandledByTranslation(expr: Expr, language:String) extends TranslatorExceptions {
  override def toString = s"the expression $expr cannot be translated in $language"
}

case class ForbiddenInFC(expr: Expr) extends TranslatorExceptions {
  override def toString = s"the expression $expr should not appear in the failure condition"
}


