package ui

/**
  * Created by kdelmas on 08/02/17.
  */

import java.util.concurrent.{Callable, FutureTask}

import scala.concurrent.{ExecutionContext, Future, Promise}
import scala.util.Try

class Cancellable[T](executionContext: ExecutionContext, todo: => T) {

  private val promise = Promise[T]()

  def future: Future[T] = promise.future

  private val jf: FutureTask[T] = new FutureTask[T](
    new Callable[T] {
      override def call(): T = todo
    }) {

    override def done(): Unit = promise.complete(Try(get()))
  }

  def cancel(): Unit = {
    if (!jf.cancel(true))
      println("not cancelled")
  }

  executionContext.execute(jf)
}

object Cancellable {
  def apply[T](todo: => T)(implicit executionContext: ExecutionContext): Cancellable[T] =
    new Cancellable[T](executionContext, todo)
}