package util.analyzers

import util.analyzers.analyzerTypes.Real
import ast.dsl.{CompAlternative, CompInstanceIdent, InstBoolIdent}

/**
  * class representing a component alternative for the SMT based analysis
  *
  * @param alternative the AST node representing component alternative
  * @param comp        the component class
  * @param time        the risk time
  */
class Alternative(alternative: CompAlternative, val comp: Component with RelationBuild with FBDDBuildSMT with FCardinalityBuild, val time: Real) {
  val lambdasValues: List[(InstBoolIdent, Real)] =
    alternative.lambdaValues.map(p => InstBoolIdent(p._1, CompInstanceIdent(List(alternative.compId.baseId))) -> Real(p._2.repr))
}
