package util.analyzers

trait Console {
  def printError(s:String) : Unit
  def printWarning(s:String):Unit
  def printResult(s:String):Unit
  def printInfo(s:String):Unit
}

trait DelegatedConsole extends Console{
  val console:Console
  def printError(s:String) : Unit = console.printError(s)
  def printWarning(s:String):Unit = console.printWarning(s)
  def printResult(s:String):Unit = console.printResult(s)
  def printInfo(s:String):Unit  = console.printInfo(s)
}

trait SystemConsole extends Console {
  def printError(s:String) : Unit= println(s)
  def printWarning(s:String):Unit= println(s)
  def printResult(s:String):Unit= println(s)
  def printInfo(s:String):Unit= println(s)
}
