package util.analyzers

import ast.dsl.CompInstanceIdent
import com.microsoft.z3.{EnumSort, Expr}

/**
  * Base trait for available DSE resolution methods
  */
trait DesignSpaceExplorationMethod

/**
  * SMT based resolution method
  */
case object SMTExploration extends DesignSpaceExplorationMethod {
  override def toString: String = "KCR Analyzer"
}


/**
  * HIPHOPS based DSE resolution method
  */
case object GeneticExploration extends DesignSpaceExplorationMethod {
  override def toString: String = "HipHOPS"
}



