package util.analyzers

import ast.dsl.InstBoolIdent

/** Base type for literals in prime implicants, in terms of DSL identifiers. */
sealed trait DslLit {
  val ident: InstBoolIdent
}

/** A negative literal. */
case class NegDslLit(ident: InstBoolIdent) extends DslLit {
  override def toString: String = (ident.instId.path :+ ident.baseId.baseId).mkString("~", ".", "")
}

/** A positive literal. */
case class PosDslLit(ident: InstBoolIdent) extends DslLit {
  override def toString: String = (ident.instId.path :+ ident.baseId.baseId).map(_.name).mkString(".")
}