package util.analyzers

import ast.dsl.InstBoolIdent
import net.sf.javabdd.BDD

/**
  * compute the BDD of the trigger function of each possible trace of the component
  */
trait FBDDBuild extends ComponentAnalyzer {
  self: Component with RelationBuild =>
  lazy val (fBDDField, fBDDEvtField) = computeFBDD()

  protected def computeFBDD(): (CharacteristicFun[BDD], Map[InstBoolIdent, BDD])
}
