package util.analyzers

import util.analyzers.analyzerTypes.Real

trait FUnreliabilityBuild extends BDDAnalyzer {
  self: Alternative =>
  val fUnr: CharacteristicFun[Real] = computeFUnr

  /**
    * Compute the new probability of component traces when substituting by this alternative
    *
    * @return characterisitc function of this alternative
    */
  private def computeFUnr = {
    val formula = (lambda: Real) => Real(1 - math.exp(-(lambda * time).toDouble))
    val unrMap = lambdasValues.map(e => comp.fBDDEvtField(e._1).`var`() -> formula(e._2)).toMap
    CharacteristicFun[Real](comp.fBDDField.func.map(p => (p._1, computeProbaBDD(p._2, unrMap))), 0)
  }
}
