package util.analyzers

import scala.collection.mutable

/**
  * Created by kdelmas on 16/11/16.
  */
sealed abstract class MyMemo[@specialized(Int) K, @specialized(Int, Long, Double) V] {
  def apply(z: K => V): K => V
}

object MyMemo {
  def mutableMapMemo[K, V](m: scala.collection.mutable.Map[K, V]): MyMemo[K, V] = new MyMemo[K, V] {
    val fun: (K => V) => K => V = f => k => {
      m.getOrElseUpdate(k, f(k))
    }

    def apply(z: K => V) = fun(z)
  }

  def mutableOpenHashMapMemo[K, V]: MyMemo[K, V] = mutableMapMemo(new mutable.OpenHashMap[K, V])
}
