package util.analyzers

import util.analyzers.analyzerTypes.DSLEventToZ3Map
import util.translators.SMTContext
import com.microsoft.z3.{Sort => Z3Sort,
  Symbol => Z3Symbol, FuncDecl => Z3FuncDecl,
  Solver => Z3Solver, BoolExpr => Z3BoolExpr,
  Expr => Z3Expr,
  BitVecExpr => Z3BitVecExpr,
  BitVecNum}
/**
  * Case class encoding the structure function of a system
  *
  * @param expr    the boolean expression of the structure function
  * @param events  the mapping of KCR events to Z3 varaibles
  * @param context the SMT evaluation context
  */
case class Phi(expr: Z3BoolExpr, events: DSLEventToZ3Map, context: SMTContext) {
  def this(phi: Phi) = {
    this(phi.expr, phi.events, phi.context)
  }
}
