package util.analyzers

/**
  * Trait fot cutsets computation on phi
  *
  * @tparam R the collection to store cutsets
  */
trait PhiCutEnumeration[R] extends PhiAnalyzer {
  self: Phi =>

  /**
    * Compute cutsets of [[Phi]] for a given cutset cardinality bound
    *
    * @param max cutset cardinality bound
    * @return cutsets
    */
  def computeCutsUntil(max: Int): Iterable[Set[R]]

  /**
    * Compute all cutsets of [[Phi]]
    *
    * @return cutsets
    */
  def computeAllCuts(): Iterable[Set[R]]

  val phiCutEnumerationProfiler: Profiler[Option[Int], Iterable[Set[R]]]
}
