package util.analyzers

import ast.dsl.InstBoolIdent
import util.io.FileManager

//Experimental => not used
trait PhiCutEnumerationTREK extends PhiCutEnumeration[InstBoolIdent] {
  self: Phi =>


  def computeCutsUntil(max: Int): Iterable[Set[InstBoolIdent]] = {
    if (this.expr.isTrue) {
      Set(Set())
    } else if (this.expr.isFalse) {
      Set()
    } else {
      val fileName = FileManager.addFileToTemp("cutEnum").getAbsolutePath
      val enumerator = new TREKPIEnumerator(this, Some(max), Some(fileName))
      enumerator.generate()._2.map(_.map(_.ident))
    }
  }


  def computeAllCuts(): Iterable[Set[InstBoolIdent]] = {
    if (this.expr.isTrue) {
      Set(Set())
    } else if (this.expr.isFalse) {
      Set()
    } else {
      val fileName = FileManager.addFileToTemp("cutEnum").getAbsolutePath
      val enumerator = new TREKPIEnumerator(this, None, Some(fileName))
      enumerator.generate()._2.map(_.map(_.ident))
    }
  }

  override val phiCutEnumerationProfiler = new Profiler[Option[Int], Iterable[Set[InstBoolIdent]]] {
    override def runWithProfile(i: Option[Int])(iterations: Int = 1): (Iterable[Set[InstBoolIdent]], ExecutionTimes) = {
      val (r, preTime) = time({
        val fileName = FileManager.addFileToTemp("cutEnum").getAbsolutePath
        new TREKPIEnumerator(self, None, Some(fileName))
      }, iterations)

      val (r2, pTime) = time({
        r.generate()
      }, iterations)

      val (r3, postTime) = time({
        r2._2.map(_.map(_.ident))
      }, iterations)
      (r3, ExecutionTimes(preTime, pTime, postTime))
    }
  }
}
