package util.analyzers

import ast.dsl.{InstBoolIdent, InstFlowIdent}
import com.microsoft.z3.{Sort => Z3Sort,
  Symbol => Z3Symbol, FuncDecl => Z3FuncDecl,
  Solver => Z3Solver, BoolExpr => Z3BoolExpr,
  Expr => Z3Expr,
  BitVecExpr => Z3BitVecExpr,
  BitVecNum}
/**
  * compute the SMT expression (c in1..inn e1..ek)=(o1..om) where flows and events are bounded variables
  */
trait RelationBuild extends ComponentAnalyzer {
  self: Component =>
  val (relExprField, relFlowField, relEvtField) = Relation()

  private def Relation(): (Z3BoolExpr, Map[InstFlowIdent, Z3BitVecExpr], Map[InstBoolIdent, Z3BoolExpr]) = {
    val outVars: Iterable[(InstFlowIdent, Z3BitVecExpr, Z3BitVecExpr)] =
      outputs.zipWithIndex.map(p => (p._1._1, p._1._2, context.mkBound(inputs.size + events.size + p._2, p._1._2.getSort).asInstanceOf[Z3BitVecExpr]))
    val equals: List[Z3BoolExpr] = outVars.map(t => context.mkEq(t._2, t._3)).toList
    (context.mkAnd(equals: _*), inputs ++ outVars.map(t => t._1 -> t._3), events.map(t => t._1 -> t._2))
  }
}
