package util.analyzers

import ast.dsl.CompInstanceIdent
import com.microsoft.z3.{EnumSort, Expr}

/**
  * Case class encoding substitution variables
  *
  * @param inst  the targeted instance
  * @param z3Var the corresponding Z3 variable
  * @param sort  the sort of the Z3 varaible
  */
case class SubstitutionVar(inst: CompInstanceIdent, z3Var: Expr, sort: EnumSort) {
  override def toString: String = s"$inst"
}
