package util.sat

/**
  * Created by rdelmas on 28/06/16.
  */
object PropToDualRailEncoder extends (Prop.Expr => (FormulaLike, PartialFunction[Prop.Atom, (Int, Int)], PartialFunction[Prop.Expr, (Int, Int)])) {

  def apply(formula: Prop.Expr): (FormulaLike, PartialFunction[Prop.Atom, (Int, Int)], PartialFunction[Prop.Expr, (Int, Int)]) = {
    val toNNF = new PropToNNF
    val nnf = toNNF(formula)
    val circuit = new FormulaLike {}
    val primaryEncoder = NNFToCircuitEncoder(nnf, circuit, switchableGates = false)
    val dualRail: FormulaLike = new FormulaLike {}
    val dualRailEncoder = new DualRailEncoder(circuit, dualRail)
    primaryEncoder.encode()
    dualRailEncoder.encode()
    val atomFunc = toNNF.atomCacheFunc andThen primaryEncoder.atomCacheFunc andThen dualRailEncoder.funcMap
    val exprFunc = toNNF.exprCacheFunc andThen primaryEncoder.exprCacheFunc andThen dualRailEncoder.funcMap
    (dualRail, atomFunc, exprFunc)
  }

}
